require "vector"
Chip = {}
function Chip.P(n)
  return Vector:new(_X(n),_Y(n),_Z(n))
end
function Chip.A(n)
  return Vector:new(_AX(n),_AY(n),_AZ(n))
end
function Chip.V(n)
  return Vector:new(_VX(n),_VY(n),_VZ(n))
end
function Chip.F(n)
  return Vector:new(_FX(n),_FY(n),_FZ(n))
end
function Chip.W(n)
  return Vector:new(_WX(n),_WY(n),_WZ(n))
end

-- `bvԍ cBase ̏xNgԂ
-- cBaseP̂ł͌łȂ̂ŁA
-- cBasẻEƑÕ`bvԍɎ
function Chip.up(cBase, cRight, cFront)
  v = (Chip.P(cFront) - Chip.P(cBase)).X(Chip.P(cRight) - Chip.P(cBase))
  return v.normalize_()
end
function Chip.vel(n)
  return Chip.V(n).length()
end
